import { Gene } from "./Gene";
import { Genetics } from "./Genetics";
export type CreatureProps = {
    genetics: Genetics;
    genes: Record<string, Gene>;
};
export declare class Creature {
    private _genes;
    private _genetics;
    constructor({ genes, genetics }: CreatureProps);
    get genetics(): Genetics;
    get random(): import("random-seed").RandomSeed;
    get genes(): {
        [x: string]: Gene;
    };
    mate(otherCreature: Creature): Creature;
}
