"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Creature = void 0;
const Gene_1 = require("./Gene");
class Creature {
    constructor({ genes, genetics }) {
        this._genes = genes;
        this._genetics = genetics;
    }
    get genetics() {
        return this._genetics;
    }
    get random() {
        return this._genetics.random;
    }
    get genes() {
        return Object.assign({}, this._genes);
    }
    mate(otherCreature) {
        return new Creature({
            genetics: this._genetics,
            genes: Object.keys(this._genes).reduce((genes, key) => {
                const { trait } = this._genes[key];
                const creatureGeneAlleles = this._genes[key].alleles;
                const otherCreatureGeneAlleles = otherCreature._genes[key].alleles;
                genes[key] = new Gene_1.Gene({
                    trait,
                    genetics: this._genetics,
                    alleles: [
                        creatureGeneAlleles[this.random(creatureGeneAlleles.length)],
                        otherCreatureGeneAlleles[this.random(otherCreatureGeneAlleles.length)],
                    ],
                });
                return genes;
            }, {}),
        });
    }
}
exports.Creature = Creature;
