import { RandomSeed } from "random-seed";
import { Gene, GeneProps } from "./Gene";
import { Allele, AlleleProps } from "./Allele";
import { Creature, CreatureProps } from "./Creature";
type GeneticsProps = {
    seed: string;
};
export declare class Genetics {
    private _seed;
    private _random;
    constructor({ seed }: GeneticsProps);
    get seed(): string;
    get random(): RandomSeed;
    createGene(props: Omit<GeneProps, "genetics">): Gene;
    createAllele(props: Omit<AlleleProps, "genetics">): Allele;
    createCreature(props: Omit<CreatureProps, "genetics">): Creature;
}
export {};
