import { Allele } from "./Allele";
import { Genetics } from "./Genetics";
export type GeneProps = {
    trait: string;
    genetics: Genetics;
    alleles: [Allele, Allele];
};
export declare class Gene {
    private _trait;
    private _alleles;
    private _genetics;
    constructor({ trait, alleles, genetics }: GeneProps);
    get genetics(): Genetics;
    get random(): import("random-seed").RandomSeed;
    get type(): "homozygous" | "heterozygous";
    get trait(): string;
    get alleles(): GeneProps["alleles"];
    get phenotype(): Allele;
}
